<?php
namespace HGA\Hgaxlfedit\Controller;

use TYPO3\CMS\Core\Utility\GeneralUtility;
/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 1970 Hans-Georg Althoff <Hans-Georg@althoff-fam.de>, HGA
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

 /**
 * EditController
 */
class EditController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

	/**
	 * List of installed extensions
	 * 
	 * @var array
	 */
	protected $listExt = NULL;

	/**
	 * List of XLF Files
	 * 
	 * @var array
	 */
	public $listXLF = NULL;

	/**
	 * Temp String
	 * 
	 * @var String
	 */
	private $Temp ='Init';

	/**
	 * Temp String
	 * 
	 * @var String
	 */
//	global $Temp1;

	/**
	 * editRepository
	 * 
	 * @var \HGA\Hgaxlfedit\Domain\Repository\EditRepository
	 * @inject
	 */
	protected $editRepository = NULL;

	/**
	 * action init
	 * 
	 * @return void
	 */
	public function initAction() {
		$files = array();
		error_log($this->Temp.'-first-'. $Temp1);
		$this->Temp = "Test Var";
		$Temp1 = 'Test Var1';
		/*		$fileRef = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\CMS\Extbase\Domain\Model\FileReference');
								$storage = 'fileadmin/'; // path relative to TYPO3 root
								$files = $fileRef->getFilesInFolder($storage);*/

		//		$fileRef = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\CMS\Core\Resource\ResourceStorage');
		//		$fileRef = $this->objectManager->get('TYPO3\CMS\Core\Resource\ResourceStorage');
		//		$fileRef = $this->objectManager->get('TYPO3\\CMS\\Extbase\\Domain\\Model\\FileReference');
		//		$folRef = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\CMS\Core\Resource\Folder');
		//		$folder = $folRef->createFolder('typo3conf/ext/hgaxlfedit/Resources/Private/Language');
		//		$files = $fileRef->getFileList('typo3conf/ext/hgaxlfedit/Resources/Private/Language');
		//		$files = \TYPO3\CMS\Core\Resource\ResourceStorage::getFileList('typo3conf/ext/hgaxlfedit/Resources/Private/Language');
		//		$folderPath ="\typo3conf\ext\hgaxlfedit\Resources\Private\Language";
		/*		$folderPath ="fileadmin/";
								$files = \TYPO3\CMS\Core\Utility\GeneralUtility::getFilesInDir($folderPath);
								$int = count($files);
								$languageOverridePath = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Resources/Private/Language/Overrides/';
								error_log(count($languageOverridePath). "-".$files[0]);
								$extensionRelativePath = substr($languageOverridePath, strlen(PATH_site));
								error_log(count($lextensionRelativePath). "-".$files[0]);

								$languageFiles = \TYPO3\CMS\Core\Utility\GeneralUtility::getFilesInDir($languageOverridePath, 'xlf');*/

		$extPath = PATH_typo3conf . 'ext/';
		$files = \TYPO3\CMS\Core\Utility\GeneralUtility::get_Dirs($extPath, '', 1, 1);
		$this->listExt = \TYPO3\CMS\Core\Utility\GeneralUtility::get_Dirs($extPath, '', 1, 1);
		//		$listExt = \TYPO3\CMS\Core\Utility\GeneralUtility::getFilesInDir(PATH_typo3conf, '', 1, 1);
		error_log($this->Temp . '-' . count($this->listExt) . '-'.count($files).'--' . PATH_typo3conf);
		$this->view->setTemplatePathAndFilename(GeneralUtility::getFileAbsFileName('EXT:hgaxlfedit/Resources/Private/Templates/Edit/default.html'));
		$this->view->assign('listExt', $this->listExt);
		$this->redirect('default');
	}

	/**
	 * action xlfFiles
	 * 
	 * @param array $extName
	 * @return void
	 */
	public function xlfFilesAction(array $extName = NULL) {
		error_log($extName['extList'][1] . '-xlfAction-' . $extName['search']);
		$xlfFiles = array();
		$xlfFiles[] = 'Test1';
		$xlfFiles[] = 'Test2';
		$this->view->assign('xlfFiles', $xlfFiles);
		$iTemp = count($view);
		error_log($view . '-view' . $iTemp . $this->initActionMethodName);
		$this->view->setTemplatePathAndFilename(GeneralUtility::getFileAbsFileName('EXT:hgaxlfedit/Resources/Private/Templates/Edit/init.html'));
		error_log(GeneralUtility::getFileAbsFileName('EXT:hgaxlfedit/Resources/Private/Templates/Edit/init.html'));
		$this->view->assign('xlfFiles', $xlfFiles);
	}

	/**
	 * action default
	 * 
	 * @return void
	 */
	public function defaultAction() {
		error_log($this->Temp."-Temp-".$Temp1);
		$this->view->setTemplatePathAndFilename(GeneralUtility::getFileAbsFileName('EXT:hgaxlfedit/Resources/Private/Templates/Edit/init.html'));
		error_log(count($this->listExt).'-default');
		$this->view->setTemplatePathAndFilename(GeneralUtility::getFileAbsFileName('EXT:hgaxlfedit/Resources/Private/Templates/Edit/default.html'));
		$this->view->assign('listExt', $this->listExt);

	}

}